/**************************************************************************************
 **                                                                                  **
 **   Le Converleeter, créé par Moonlight Dreamer.                                   **
 **                                                                                  **
 **   ----------------------------------------------------------------------------   **
 **                                                                                  **
 **   Copyright (c) 2011 ANDRE Guillaume                                             **
 **   All rights reserved.                                                           **
 **                                                                                  **
 **   Redistribution and use in source and binary forms, with or                     **
 **   without modification, are permitted provided that the following                **
 **   conditions are met:                                                            **
 **                                                                                  **
 **   Redistributions of source code must retain the above copyright                 **
 **   notice, this list of conditions and the following disclaimer.                  **
 **   Redistributions in binary form must reproduce the above copyright              **
 **   notice, this list of conditions and the following disclaimer in                **
 **   the documentation and/or other materials provided with the distribution.       **
 **   Neither the name of the copyright holder nor the names of its                  **
 **   contributors may be used to endorse or promote products derived from           **
 **   this software without specific prior written permission.                       **
 **                                                                                  **
 **   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS            **
 **   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT              **
 **   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS              **
 **   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT       **
 **   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,          **
 **   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED       **
 **   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,            **
 **   OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY         **
 **   OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING        **
 **   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,   **
 **   EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                             **
 **                                                                                  **
 **************************************************************************************/


#include "FenEntreeTexte.h"
#include "FenPersonnalisation.h"
#include "conversions.h"

using namespace std;

FenEntreeTexte::FenEntreeTexte()
{
    setupUi(this);
    setWindowIcon(QIcon("IMAGES/logo.png"));

    m_moon->setIcon(QIcon("IMAGES/debian.png"));
    m_red->setIcon(QIcon("IMAGES/ubuntu.png"));
    m_modeEmploi->setIcon(QIcon("IMAGES/modeemploi.png"));
    m_aPropos->setIcon(QIcon("IMAGES/apropos.png"));
    m_misesAJour->setIcon(QIcon("IMAGES/maj.png"));

    m_texte->setFontItalic(true);
    m_texte->setPlainText("Entrez le texte à traduire ici...");
    m_effacer = true;
    m_supprAlphabet = false;

    connect(m_quitter, SIGNAL(clicked()), qApp, SLOT(quit()));
}


FenEntreeTexte::~FenEntreeTexte()
{
    if(m_supprAlphabet)
    {
        for(unsigned char i(0) ; i < 26 ; i++)
          delete m_alphabet[i];
    }
}


QString FenEntreeTexte::ajouterGuillemets(QString chemin)
{
    if(chemin[chemin.size() - 1] != '/')
      chemin += '/';

    for(int i(0) ; i < chemin.size() ; i++)
    {
        if(chemin[i] == ' ')
        {
            for(int j(i) ; j > 0 ; j--) // On recule jusqu'à trouver un slash.
            {
                if(chemin[j] == '/')
                {
                    if(chemin[j + 1] != '\"') // Si il n'y a pas déjà un guillemet, on en met un.
                    {
                        chemin.insert(j + 1, "\"");
                        break;
                    }
                }
            }

            for(int j(i) ; j < chemin.size() ; j++) // On avance jusqu'à trouver un slash.
            {
                if(chemin[j] == '/')
                {
                    if(chemin[j] != '\"') // Si il n'y a pas déjà un guillemet, on en met un.
                    {
                        chemin.insert(j, "\"");
                        i = j;
                        break;
                    }
                }
            }
        }
    }
    return chemin;
}


void FenEntreeTexte::on_m_moon_triggered()
{
    QDialog *fenetre = new QDialog(this);
      fenetre->setWindowTitle("Moonlight Dreamer");
      fenetre->setWindowIcon(QIcon("IMAGES/debian.png"));

    QGridLayout *layout = new QGridLayout;
    QLabel *label[5];
      label[0] = new QLabel("<center><strong><u>Style d'écriture de Moonlight Dreamer :</u></strong></center><br />");
      label[1] = new QLabel("A  :  /-\\\n\nB  :  8\n\nC  :  (\n\nD  :  |)\n\nE  :  3\n\nF  :  |=\n\nG  :  6");
      label[2] = new QLabel("H  :  |-|\n\nI  :  !\n\nJ  :  _|\n\nK  :  |<\n\nL  :  1\n\nM  :  |\\/|\n\nN  :  |\\|");
      label[3] = new QLabel("O  :  ()\n\nP  :  |>\n\nQ  :  9\n\nR  :  |2\n\nS  :  5\n\nT  :  7\n\nU  :  |_|");
      label[4] = new QLabel("V  :  \\/\n\nW  :  \\/\\/\n\nX  :  )(\n\nY  :  Y\n\nZ  :  2");

    QFrame *separation[3];
    for(unsigned char i(0) ; i < 3 ; i++)
    {
        separation[i] = new QFrame;
        separation[i]->setFrameShape(QFrame::VLine);
    }

    layout->addWidget(label[0], 0, 0, 1, 7);
    layout->addWidget(label[1], 1, 0);
    layout->addWidget(separation[0], 1, 1);
    layout->addWidget(label[2], 1, 2);
    layout->addWidget(separation[1], 1, 3);
    layout->addWidget(label[3], 1, 4);
    layout->addWidget(separation[2], 1, 5);
    layout->addWidget(label[4], 1, 6);

    fenetre->setLayout(layout);
    fenetre->show();
}


void FenEntreeTexte::on_m_red_triggered()
{
    QDialog *fenetre = new QDialog(this);
      fenetre->setWindowTitle("Roujucad");
      fenetre->setWindowIcon(QIcon("IMAGES/ubuntu.png"));

    QGridLayout *layout = new QGridLayout;
    QLabel *label[5];
      label[0] = new QLabel("<center><strong><u>Style d'écriture de Roujucad :</u></strong></center><br />");
      label[1] = new QLabel("A  :  /-\\\n\nB  :  |3\n\nC  :  (\n\nD  :  |)\n\nE  :  3\n\nF  :  |=\n\nG  :  6");
      label[2] = new QLabel("H  :  |-|\n\nI  :  |\n\nJ  :  _|\n\nK  :  |<\n\nL  :  |_\n\nM  :  |\\/|\n\nN  :  |\\|");
      label[3] = new QLabel("O  :  ()\n\nP  :  |>\n\nQ  :  (,)\n\nR  :  |2\n\nS  :  5\n\nT  :  7\n\nU  :  |_|");
      label[4] = new QLabel("V  :  \\/\n\nW  :  \\/\\/\n\nX  :  )(\n\nY  :  Y\n\nZ  :  2");


    QFrame *separation[3];
    for(unsigned char i(0) ; i < 3 ; i++)
    {
        separation[i] = new QFrame;
        separation[i]->setFrameShape(QFrame::VLine);
    }

    layout->addWidget(label[0], 0, 0, 1, 7);
    layout->addWidget(label[1], 1, 0);
    layout->addWidget(separation[0], 1, 1);
    layout->addWidget(label[2], 1, 2);
    layout->addWidget(separation[1], 1, 3);
    layout->addWidget(label[3], 1, 4);
    layout->addWidget(separation[2], 1, 5);
    layout->addWidget(label[4], 1, 6);

    fenetre->setLayout(layout);
    fenetre->show();
}


void FenEntreeTexte::on_m_modeEmploi_triggered()
{
    QDialog *fenetre = new QDialog(this);
      fenetre->setWindowTitle("Mode d'emploi du Converleeter");
      fenetre->setWindowIcon(QIcon("IMAGES/modeemploi.png"));

    QVBoxLayout *layout = new QVBoxLayout;

    QLabel *label = new QLabel("<strong>-Écriture de Moonlight Dreamer :</strong>Le logiciel<br />"
      "va traduire vos textes avec le style d'écriture de Moonlight Dreamer que vous<br />"
      "pouvez aller consulter dans la partie \"Écritures\".<br />"
    "<strong>-Écriture de Roujucad :</strong> Même chose que pour Moonlight Dreamer.<br />"
    "<strong>-Ajouter / Supprimer les espaces :</strong> Ces deux options vont de pair :<br />Certaines fois, "
      "il peut y avoir des problèmes avec la traduction.<br /><u>Ex :</u> avec \"|_|_|_|\"), si les lettres "
      "sont séparées par des espaces alors<br />il n'y aura pas de confusions durant la traduction "
      "leet->français et vous<br />pourrez ainsi choisir de supprimer les espaces inutiles.");

    layout->addWidget(label);
    fenetre->setLayout(layout);
    fenetre->show();
}


void FenEntreeTexte::on_m_aPropos_triggered()
{
    QDialog *fenetre = new QDialog(this);
      fenetre->setWindowTitle("À Propos...");
      fenetre->setWindowIcon(QIcon("IMAGES/apropos.png"));
      fenetre->setFixedSize(0, 0);

    QGridLayout *layout = new QGridLayout;

    QLabel *label = new QLabel("Le Converleeter<br />Version 1.4<br />Créé par Moonlight Dreamer<br /><br />"
    "Toutes les images (exceptées le logo du<br />Converleeter, de Debian et d'Ubuntu)<br /> ont été prises "
    "sur <a href=\"http://www.everaldo.com\" title=""Everaldo"">Everaldo.com</a>");
      label->setOpenExternalLinks(true);

    QFrame *separation = new QFrame;
      separation->setFrameShape(QFrame::HLine);

    QPushButton *ok = new QPushButton("OK");
      ok->setDown(true);
      connect(ok, SIGNAL(clicked()), fenetre, SLOT(close()));

    layout->addWidget(label, 0, 0, 1, 2);
    layout->addWidget(separation, 1, 0, 1, 2);
    layout->addWidget(ok, 2, 1);
    fenetre->setLayout(layout);
    fenetre->exec();
}


void FenEntreeTexte::on_m_misesAJour_triggered()
{
    ofstream flux("version.moon");

    if(flux)
      flux << "1.14";
    else
    {
        QMessageBox::critical(this, "Erreur", "Impossible de vérifier l'existence d'une mise à jour.<br />"
        "Veuillez réessayer de lancer le logiciel en mode administrateur.");
        qApp->quit();
        return;
    }

    #ifdef Q_OS_LINUX
      QFile maj("maj");
      if(!maj.exists())
        QMessageBox::critical(this, "Erreur", "Impossible de trouver le logiciel de mise à jour.");
      else
        QProcess::startDetached(ajouterGuillemets(QDir::currentPath() + "/") + "maj");
    #endif

    #ifdef Q_OS_WIN32
      QFile maj("maj.exe");
      if(!maj.exists())
        QMessageBox::critical(this, "Erreur", "Impossible de trouver le logiciel de mise à jour.");
      else
        QProcess::startDetached("maj.exe");
    #endif
}


void FenEntreeTexte::on_m_personnaliser_clicked()
{
    m_modifie = false;

    FenPersonnalisation *fenPersonnalisation = new FenPersonnalisation(&m_modifie, this);
    fenPersonnalisation->show();
    m_alphabet = fenPersonnalisation->getAlphabet();
    m_supprAlphabet = true;
}


void FenEntreeTexte::on_m_frLeet_released()
{
    m_supprimerEspaces->setChecked(false);
}


void FenEntreeTexte::on_m_leetFr_released()
{
    m_mettreEspaces->setChecked(false);
    m_doublerAntislashs->setChecked(false);
}


void FenEntreeTexte::on_m_texte_selectionChanged()
{
    if(m_effacer)
    {
        m_texte->clear();
        m_texte->setFontItalic(false);
        m_effacer = false;
    }
}


void FenEntreeTexte::on_m_traduire_clicked()
{
    bool aucunTexte(true);

    // On vérifie si l'utilisateur a entré des lettres.
    for(int i(0) ; i < m_texte->toPlainText().size() ; i++)
    {
        if(m_texte->toPlainText()[i] != ' ' && m_texte->toPlainText()[i] != '\n'
           && m_texte->toPlainText()[i] != '\t' && m_texte->toPlainText()[i] != '\0')
        {
            aucunTexte = false;
            break;
        }
    }

    if(!m_ecritureMoon->isChecked() && !m_ecritureRed->isChecked() && !m_ecriturePerso->isChecked())
    {
        QMessageBox::critical(this, "Erreur", "Vous n'avez pas choisi le type de traduction.");
        return;
    }

    if(!m_leetFr->isChecked() && !m_frLeet->isChecked())
    {
        QMessageBox::critical(this, "Erreur", "Vous n'avez pas indiqué le sens de conversion.");
        return;
    }

    if(m_texte->toPlainText().isEmpty() || aucunTexte)
    {
        QMessageBox::critical(this, "Erreur", "Vous n'avez pas entré de texte.");
        return;
    }

    QString texteTraduit("");

    if(m_frLeet->isChecked()) // Si on veut traduire du français vers le leet.
    {
        if(m_ecritureMoon->isChecked()) // Si Moonlight Dreamer est coché.
          texteTraduit = tradEnLeet(m_texte->toPlainText(), 1, m_doublerAntislashs->isChecked(),
          m_mettreEspaces->isChecked());
        else if(m_ecritureRed->isChecked()) // Si Roujucad est coché.
          texteTraduit = tradEnLeet(m_texte->toPlainText(), 2, m_doublerAntislashs->isChecked(),
          m_mettreEspaces->isChecked());
        else if(m_ecriturePerso->isChecked()) // Si Personnaliser est coché.
        {
            if(m_modifie)
              texteTraduit = tradEnLeet(m_texte->toPlainText(), 3, m_doublerAntislashs->isChecked(),
              m_mettreEspaces->isChecked(), m_alphabet);
            else
            {
                QMessageBox::critical(this, "Erreur", "<center>Vous n'avez pas validé votre personnalisation.</center>");
                return;
            }
        }

    }

    else if(m_leetFr->isChecked()) // Si on veut traduire du leet vers le français.
    {
        if(m_ecritureMoon->isChecked()) // Si Moonlight Dreamer est coché.
          texteTraduit = tradEnFr(m_texte->toPlainText(), 1, m_supprimerEspaces->isChecked());
        else if(m_ecritureRed->isChecked()) // Si Roujucad est coché.
          texteTraduit = tradEnFr(m_texte->toPlainText(), 2, m_supprimerEspaces->isChecked());
        else if(m_ecriturePerso->isChecked()) // Si Personnaliser est coché.
        {
            if(m_modifie)
              texteTraduit = tradEnFr(m_texte->toPlainText(), 3, m_supprimerEspaces->isChecked(), m_alphabet);
            else
            {
                QMessageBox::critical(this, "Erreur", "<center>Vous n'avez pas validé votre personnalisation.</center>");
                return;
            }
        }
    }

    if(texteTraduit.isEmpty() || aucunTexte)
    {
        QMessageBox::critical(this, "Erreur", "Vous n'avez entré aucun texte<br />"
        "ou vous avez utilisé des symboles inconnus.");
        return;
    }

    else
    {
        QDialog *fenetre = new QDialog(this);
          fenetre->setWindowTitle("Texte traduit");
        QVBoxLayout *layout = new QVBoxLayout;
        QTextEdit *texte = new QTextEdit;
          texte->setPlainText(texteTraduit);

        layout->addWidget(texte);
        fenetre->setLayout(layout);
        fenetre->exec();
    }
}














