/**************************************************************************************
 **                                                                                  **
 **   Le Converleeter, créé par Moonlight Dreamer.                                   **
 **                                                                                  **
 **   ----------------------------------------------------------------------------   **
 **                                                                                  **
 **   Copyright (c) 2011 ANDRE Guillaume                                             **
 **   All rights reserved.                                                           **
 **                                                                                  **
 **   Redistribution and use in source and binary forms, with or                     **
 **   without modification, are permitted provided that the following                **
 **   conditions are met:                                                            **
 **                                                                                  **
 **   Redistributions of source code must retain the above copyright                 **
 **   notice, this list of conditions and the following disclaimer.                  **
 **   Redistributions in binary form must reproduce the above copyright              **
 **   notice, this list of conditions and the following disclaimer in                **
 **   the documentation and/or other materials provided with the distribution.       **
 **   Neither the name of the copyright holder nor the names of its                  **
 **   contributors may be used to endorse or promote products derived from           **
 **   this software without specific prior written permission.                       **
 **                                                                                  **
 **   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS            **
 **   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT              **
 **   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS              **
 **   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT       **
 **   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,          **
 **   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED       **
 **   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,            **
 **   OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY         **
 **   OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING        **
 **   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,   **
 **   EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                             **
 **                                                                                  **
 **************************************************************************************/


#ifndef FENPERSONNALISATION_HPP
#define FENPERSONNALISATION_HPP

#include <QMessageBox>
#include <QLineEdit>
#include <QSettings>
#include <QFormLayout>
#include <QLabel>
#include <QFileDialog>
#include <QCloseEvent>

#include <fstream>

#include "ui_FenPersonnalisation.h"

class FenPersonnalisation : public QMainWindow, private Ui::FenChoixEcriture
{
    Q_OBJECT

    public:

      explicit FenPersonnalisation(bool *modifie, QWidget *parent);
      ~FenPersonnalisation();
      QString trouverNomFichier() const;
      bool verifierCases() const;
      QLineEdit **getAlphabet();

    protected:

      virtual void closeEvent(QCloseEvent *event);

    private slots:

      void on_m_nouveau_triggered();
      void on_m_ouvrir_triggered();
      void on_m_enregistrer_triggered();
      void on_m_enregistrerSous_triggered();
      void on_m_precisions_triggered();

      void on_m_reinitialiser_clicked();

      void on_m_annuler_clicked();
      void on_m_valider_clicked();

      void texteChange();

    private:

      QLineEdit *m_alphabet[26];
      QString m_chemin;
      QLabel *m_nomFichierBas;
      bool *m_modifie;
      bool m_fermerFenetre;
      bool m_mettreEtoile;

};

#endif // FENPERSONNALISATION_HPP














